/* Pcap to flow tool */
#ifndef  PROTDEFS_H_INCLUDED
#define  PROTDEFS_H_INCLUDED

typedef unsigned short USHORT;
typedef unsigned char UCHAR;
typedef unsigned long ULONG; 

/* UDP header */
typedef struct udp_header{
	USHORT	src_port;		
	USHORT	dst_port;	
	USHORT	len;	
	USHORT	checksum;	
}udp_header;


/* TCP header */
typedef struct tcp_header{
	USHORT	src_port;		
	USHORT	dst_port;	
	ULONG	seq_no;		
	ULONG  ack_no;		
	USHORT	flags_off;
	USHORT window;	
	USHORT	crc;		
	USHORT	urgent;		
}tcp_header;

/* 4 bytes IP address */
typedef struct ip_address{
	UCHAR byte1;
	UCHAR byte2;
	UCHAR byte3;
	UCHAR byte4;
}ip_address;

/* IPv4 header */
/* changed tlen from uchar[2] to ushort */
typedef struct ip_header{
	UCHAR	ver_ihl;		// Version (4 bits) + Internet header length (4 bits)
	UCHAR	tos;			// Type of service 
	USHORT	tlen;			// Total length 
	UCHAR  identifier[2]; // Identification
	USHORT flags_fo;		// Flags (3 bits) + Fragment offset (13 bits)
	UCHAR	ttl;			// Time to live
	UCHAR	proto;			// Protocol
	USHORT crc;			// Header checksum
	ip_address	saddr;		// Source address
	ip_address	daddr;		// Destination address
	UCHAR 	op_pad[4];		// Option + Padding
}ip_header;

/*
 * Ethernet address - 6 octets
 */
typedef struct ether_addr {
        UCHAR ether_addr_octet[6];
} ether_addr;


/*
 * Structure of a 10Mb/s Ethernet header.
 */
typedef struct  ether_header {
        struct  ether_addr ether_dhost;
        struct  ether_addr ether_shost;
        USHORT  ether_type;
} ether_header;

#endif
