#include "pcap.h"
#include "ProtDefs.h"
#include <vector>


bool processpacket(char * , size_t, int *,int [] , int);
bool sendpacket(int ,char * , int);

struct sockaddr_in socket_in;

int main(int argc,char **argv)
{
	int opt_ports[10];	
	int num_of_ports=0;
	int usecs;
	int k=0;

	opt_ports[0]=2055;
	num_of_ports=1;

	//Creating a vector	
	 typedef vector <string> VECTORSTRINGS;
	VECTORSTRINGS argv_strings;
	for(int i=0;i<argc;i++)	
	{
		argv_strings.push_back(argv[i]);
	}
	
	string strCaptureFile, strIPAddress, strPort;
	for(int i=1;i<argv_strings.size();i++)
	{
		if(argv_strings[i]=="-ports")
 		{
			num_of_ports=0;

			string tmp_port = argv_strings[i+1];

			char * oneportstr = strtok((char*) tmp_port.c_str(),","); 	
			while (oneportstr)
			{
				printf("Found one port = %s\n", oneportstr);
				opt_ports[k] = atoi(oneportstr);
				k++;
				num_of_ports++;
				oneportstr = strtok(NULL,","); 	
			}
			i++;
		}
		else if(argv_strings[i]=="-gapus")
		{
			string tmp_usec = argv_strings[i+1];
			usecs = atoi(tmp_usec.c_str());
			printf("found gapus = %d\n", usecs);
			i++;
		}
		else
		{
			if (strCaptureFile=="")
				strCaptureFile=argv_strings[i];
			else if (strIPAddress=="")
				strIPAddress = argv_strings[i];	
			else if (strPort=="")
				strPort = argv_strings[i];
		}
	}


	int socket_creation;
 	if((socket_creation = socket( AF_INET , SOCK_DGRAM ,0))==0)
	{
		printf("Cannot open socket \n");
		exit(1);
	}

	unsigned short port_number = atoi(strPort.c_str());
	
	memset(&socket_in ,0 , sizeof(socket_in));
	socket_in.sin_family = AF_INET;
	socket_in.sin_port = htons(port_number);
	if(inet_aton(strIPAddress.c_str() , &socket_in.sin_addr)==0)
	{
		printf("Usage: %s capture.pcap receiver-ip receiver-port [-ports p1,p2.. -gapus gus]\n", argv[0]);
		printf("       Parameters : p1,p2 = List of netflow ports in the capture file\n");
		printf("                    gus   = Interval in us between each packet sent\n");
		printf("\nExample: %s dump1.pcap 192.168.1.18 -ports 2055,8055 -gaus 20\n", argv[0]);
		exit(1); 	
	}
	
	FILE * fp;
	fp = fopen(strCaptureFile.c_str(),"r+");
	
	PCAP_FILE_HEADER_T pcap_read;
	size_t read = fread(&pcap_read, sizeof(PCAP_FILE_HEADER_T),1,fp);
	
	printf("\nMAGIC NUMBER  :                        %lx \n",pcap_read.magic_number);
	printf("\nVERSION MAJOR :                        %d \n",pcap_read.version_major);
	printf("\nVERSION MINOR :                        %d \n",pcap_read.version_minor);
	printf("\nTHIS ZONE     :                        %lx \n",pcap_read.thiszone);
	printf("\nSIGFIGS       :                        %lx \n",pcap_read.sigfigs);
	printf("\nSNAPLEN       :                        %lx \n",pcap_read.snaplen);
	printf("\nNETWORK       :                        %lx \n",pcap_read.network);
	
	long total_packets  =  0;
	long netflows       =  0;
	long sent_packets   =  0;	
	char buff[65000];
	
	while(!feof(fp))
	{
		PCAP_PACKET_HEADER_T pcap_packet;
		size_t  nread = fread(&pcap_packet , sizeof(PCAP_PACKET_HEADER_T),1,fp);
		if(nread==0)
		{
			break;	
		}	
		
		total_packets += 1;
		
		size_t read1 = fread(&buff[0] ,pcap_packet.incl_len,1,fp);
		if(read1==0)
		{
			break;
		}
		
		int nflen=0;
		if(processpacket(&buff[0],pcap_packet.incl_len,&nflen,opt_ports,num_of_ports)) 
		{
			netflows +=1;	
			int final_length = pcap_packet.incl_len - nflen;
			
			if(sendpacket(socket_creation, &buff[nflen], final_length))
			{
				usleep(usecs);
				sent_packets +=1;
			}		
		}
	}

	printf("Total packets in file      : %ld\n", total_packets);
	printf("The number of netflows are : %ld\n", netflows);
	printf("The number of packets sent : %ld\n", sent_packets);
	
	fclose(fp);
	return 0;
}
