#include "pcap.h"
#include "ProtDefs.h"

bool 	processpacket(char * packet_data, size_t length,  int * pLength, int udp_ports[] , int portlength)
{
	char * temp_ptr = packet_data;
	size_t temp_size = sizeof(ether_header) + sizeof(ip_header) + sizeof(udp_header);
	
	// test 1 : check if enough bytes are in the packet
	if(length <  temp_size)
	{
		return false;
	}	
	
	// test 2 : chec if ethertype = 0x800
	ether_header * pether_read = (ether_header*) temp_ptr;
	if((ntohs(pether_read ->ether_type))!=0x800)
	{
		return false;
	}
	int ether_size=sizeof(ether_header);	
	
	temp_ptr += sizeof(ether_header);
	ip_header * pip_read = (ip_header *) temp_ptr;
	int tmp_and = pip_read ->ver_ihl & 15; 	
	int tmp_bit = tmp_and * 4;
	
	if(pip_read->proto!=0x11)
	{
		return false;
	}
	int ip_size = tmp_bit;
		
	temp_ptr += tmp_bit;
	udp_header * udp_read = (udp_header *) temp_ptr; 
	short tmp_dst = ntohs(udp_read->dst_port);	
	
	// return the header sizes
	int udp_size = sizeof(udp_header);
	int length_size = ether_size + ip_size + udp_size;	
	*pLength = length_size;

	// see if there is a netflow port match
	if(portlength!=0)
	{
		for(int i=0;i<portlength;i++)
		{
			if(tmp_dst==udp_ports[i]) 
				return true;;
		}		
		return false;
	}	

	return true;
}
